Subject: Re: Interrupt routing broken on TiBook IV with 2.6.21.x ?

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 22 May 2007 08:11:41 +1000

On Mon, 2007-05-21 at 22:08 +0200, Christian Böhme wrote:
> Benjamin Herrenschmidt wrote:
> 
> > Nope... it can't be a routing problem since interrupt -is- routed (you
> > are getting it !)
> 
> Actually, these were the exact words from the ALSA developer.  For some
> reason, however, the interrupt count does not increase after some (variable)
> time.  It looks as if the ALSA code waits for but not receiving them.  After
> a restart, an audio signal does leave the jack and the interrupt count
> increases but only for about a second (sometimes more, often less).  No idea 
> whether interrupts must be routed/are routable on this very machine I have at 
> all ...

Or it could be the DMA channel going dead though I fail to see why it
would just start doing that now.

> > Which exact tipb model is this ? (cat /proc/device-tree/model)
> 
> PowerBook3,5 of the 2002-11 release variety.

Ok, I think I have access to one of these, I'll try to reproduce myself.

> I stuck to OSS up to the 2.6.19.x kernels where everything (surprisingly)
> ``just worked''.  Then came the 2.6.20.x series and <root>/sound/oss/\
> dmasound/dmasound_awacs.c started spitting out loads of ``tx-irq: xfer died -
> patching it up...'' messages with stuttering audio output but nothing
> different in their respective implementations from 2.6.19.x to 2.6.20.x.
> 
> Is there anything particular I can dive into myself to expedite finding the
> cause of the problem without learning the full details of the PPC implemen-
> tation ?

Not sure where to start :-) I'll first see if I can reproduce.

Cheers,
Ben.